<template>
    <div class="flex items-center border-b bg-gray-100">
        <div class="w-36 flex items-center justify-center gap-3">
            <span>A</span>
            <div class="radio-custom">
                <input
                    id="true-answer"
                    type="radio"
                    value="0"
                    v-model="answerChecked"
                    :checked="listAnswer[0].right === QUIZ_CHECKED"
                />
                <label for="true-answer">&nbsp;</label>
            </div>
        </div>
        <div class="flex-1 p-3 border-l bg-white">
            <QuillEditor
                :content="listAnswer[0].key"
                readOnly
                height="150"
                placeholder=""
            />
        </div>
    </div>
    <div class="flex items-center border-b bg-gray-100">
        <div class="w-36 flex items-center justify-center gap-3">
            <span>B</span>
            <div class="radio-custom">
                <input
                    id="false-answer"
                    type="radio"
                    value="1"
                    v-model="answerChecked"
                    :checked="listAnswer[1].right === QUIZ_CHECKED"
                />
                <label for="false-answer">&nbsp;</label>
            </div>
        </div>
        <div class="flex-1 p-3 border-l bg-white">
            <QuillEditor
                :content="listAnswer[1].key"
                placeholder=""
                readOnly
                height="150"
            />
        </div>
    </div>
</template>

<script>
import { onMounted, ref, watch } from "vue";
import { QUIZ_NOT_CHECKED, QUIZ_CHECKED } from "@/constants";

import QuillEditor from "@/components/quill-editor/QuillEditorVue3.vue";

export default {
    components: {
        QuillEditor
    },
    props: {
        answers: {
            type: Array,
            required: true
        }
    },
    setup(props, context) {
        const answerChecked = ref(null);

        let listAnswer = [
            {
                key: "Đúng",
                right: props.answers[0]
                    ? props.answers[0].right
                    : QUIZ_NOT_CHECKED
            },
            {
                key: "Sai",
                right: props.answers[1]
                    ? props.answers[1].right
                    : QUIZ_NOT_CHECKED
            }
        ];

        onMounted(() => {
            context.emit("update:answers", listAnswer);
        });

        watch(answerChecked, newValue => {
            // reset select answer
            listAnswer = listAnswer.map(answer => {
                return { ...answer, right: QUIZ_NOT_CHECKED };
            });

            listAnswer[newValue].right = QUIZ_CHECKED;

            context.emit("update:answers", listAnswer);
        });

        return { QUIZ_CHECKED, listAnswer, answerChecked };
    }
};
</script>
